jobs/urls.py
from django.urls import path
import jobs.views
import jobs.models

app_name = "jobs"

urlpatterns = [
    path("", jobs.views.Index.as_view(), name="index"),
    path("executions/", jobs.views.Executions.as_view(), name="executions"),
    path("executions/id/<int:id>", jobs.views.Executions.as_view(), name="execution"),
    path(
        "executions/job/<str:job_id>",
        jobs.views.Executions.as_view(),
        name="executions_job",
    ),
    path("results/", jobs.views.Results.as_view(), name="results"),
    path(
        "results/id/<int:job_execution_id>", jobs.views.Results.as_view(), name="result"
    ),
    path("results/job/<str:job>", jobs.views.Results.as_view(), name="results_job"),
]

nsp/urls.py
import api.views
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path

from drf_yasg import openapi
from drf_yasg.views import get_schema_view

from rest_framework import routers, permissions
from rest_framework.authtoken import views
from django.template.defaulttags import register


@register.filter
def get_item(dictionary, key):
    return dictionary.get(key)


openapi_info = openapi.Info(
    title="NSP",
    default_version="0.1.0",
    description="Network Science Platform",
    contact=openapi.Contact(email="keith.birdsall@aicloud.guru"),
    license=openapi.License(name="MIT License"),
)

schema_view = get_schema_view(
    openapi_info,
    public=True,
    permission_classes=[permissions.AllowAny],
)


class OptionalSlashRouter(routers.DefaultRouter):
    def __init__(self):
        super().__init__()
        self.trailing_slash = "/?"


api_router = OptionalSlashRouter()

api_router.register(r"admin/users", api.views.UserViewSet)
api_router.register(r"admin/groups", api.views.GroupViewSet)

api_router.register(r"tenants", api.views.TenantViewSet)
api_router.register(r"epgs", api.views.EndpointGroupViewSet)
api_router.register(r"jobs", api.views.JobViewSet)
api_router.register(r"executions", api.views.JobExecutionViewSet)
api_router.register(r"results", api.views.JobResultViewSet)
api_router.register(r"devices", api.views.DeviceViewSet)
api_router.register(r"dashboards", api.views.DashboardViewSet)
api_router.register(r"networks", api.views.BaseNetworkViewSet)
api_router.register(r"vrfs", api.views.VrfViewSet)
api_router.register(r"l3vnis", api.views.L3VniViewSet)
api_router.register(r"vlans", api.views.VlanViewSet)
api_router.register(r"interfaces", api.views.InterfaceViewSet)
#api_router.register(r"snapshots", api.views.SnapshotViewSet)

urlpatterns = [
    path("admin/", admin.site.urls),
    path("api-auth/", include("rest_framework.urls", namespace="rest_framework")),
    path("api-token-auth/", views.obtain_auth_token),
    path("api/", include(api_router.urls)),
    # path("api/epgs/", api.views.EndpointGroupList.as_view()),
    # path("api/epgs/<int:id>/", api.views.EndpointGroupDetail.as_view()),
    path("login/", include("login.urls")),
    path("networks/", include("networks.urls")),
    path("jobs/", include("jobs.urls")),
    path("dashboards/", include("dashboards.urls")),
    path("settings/", include("settings.urls")),
    path("devices/", include("devices.urls")),
    re_path(
        r"^api/swagger(?P<format>\.json|\.yaml)$",
        schema_view.without_ui(cache_timeout=0),
        name="schema-json",
    ),
    re_path(
        r"^api/swagger/$",
        schema_view.with_ui("swagger", cache_timeout=0),
        name="schema-swagger-ui",
    ),
    re_path(
        r"^api/redoc/$",
        schema_view.with_ui("redoc", cache_timeout=0),
        name="schema-redoc",
    ),
    path("", include("devices.urls")),
    path("", include("django_prometheus.urls")),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)

jobs/models.py
from django.db import models
from django.contrib.postgres.fields import ArrayField
from django_prometheus.models import ExportModelOperationsMixin


class BaseJobResult(ExportModelOperationsMixin("result"), models.Model):
    id = models.AutoField(primary_key=True)
    job_execution_id = models.IntegerField(blank=True)
    job_id = models.CharField(max_length=100, blank=True, null=True)
    cmd = models.CharField(max_length=255, blank=True, null=True)
    stdout = models.TextField()

jobs/views.py
import jobs.models
import utils.helpers
import pickle
from asgiref.sync import sync_to_async
from django_apscheduler.models import DjangoJobExecution, DjangoJob
from django.http import HttpResponseRedirect
from django.shortcuts import render
from django.views import generic
from datetime import datetime


class Index(generic.View):
    async def get(self, request):
        if not await utils.helpers.is_authenticated(request):
            return HttpResponseRedirect("/login/")
        objects = await sync_to_async(list)(DjangoJob.objects.all())
        jobs = []
        for object in objects:
            object = object.__dict__
            job_state = pickle.loads(object["job_state"])
            next_run_time = object.get("next_run_time")
            if next_run_time:
                next_run_time = next_run_time.isoformat()
            job = utils.helpers.set_dict_vals(
                object,
                {
                    "_state": None,
                    "job_state": None,
                    "func": job_state["func"],
                    "args": f'{job_state["args"]}',
                    "kwargs": job_state["kwargs"],
                    "max_instances": job_state["max_instances"],
                    "next_run_time": next_run_time,
                },
            )
            jobs.append(job)
        return render(
            request,
            "jobs/index.html",
            {"jobs": jobs},
        )


class Executions(generic.View):
    async def get(self, request, id=None, job_id=None):
        if not await utils.helpers.is_authenticated(request):
            return HttpResponseRedirect("/login/")
        if id:
            object = await sync_to_async(
                DjangoJobExecution.objects.get, thread_sensitive=True
            )(id=id)
            objects = [object]
        elif job_id:
            objects = await sync_to_async(list)(
                DjangoJobExecution.objects.filter(job_id=job_id)[:1000]
            )
        else:
            objects = await sync_to_async(list)(DjangoJobExecution.objects.all()[:1000])
        executions = []
        for object in objects:
            object = object.__dict__
            finished = object["finished"]
            duration = object["duration"]
            if finished:
                finished = datetime.fromtimestamp(float(object["finished"])).isoformat()
            data_map = {
                "_state": None,
                "run_time": object["run_time"].isoformat(),
                "finished": finished or "-",
                "duration": duration or "-",
                "exception": object["exception"] or "",
                "traceback": object["traceback"] or "",
            }
            executions.append(utils.helpers.set_dict_vals(object, data_map))
        return render(
            request,
            "jobs/executions.html",
            {"executions": executions},
        )


class Results(generic.View):
    async def get(self, request, job_execution_id=None, job=None):
        if not await utils.helpers.is_authenticated(request):
            return HttpResponseRedirect("/login/")
        if job_execution_id:
            results = await sync_to_async(list)(
                jobs.models.BaseJobResult.objects.filter(
                    job_execution_id=job_execution_id
                ).order_by("-job_execution_id")
            )
        elif job:
            results = await sync_to_async(list)(
                jobs.models.BaseJobResult.objects.filter(job_id=job).order_by(
                    "-job_execution_id"
                )[:1000]
            )
        else:
            results = await sync_to_async(list)(
                jobs.models.BaseJobResult.objects.all().order_by("-job_execution_id")[
                    :1000
                ]
            )
        return render(
            request,
            "jobs/results.html",
            {"results": results},
        )

jobs/templates/jobs/executions.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="{% url 'jobs:index' %}">Jobs</a></li>
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'jobs:executions' %}">Executions</a>
      </li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<div class="row">
  <div class="col-lg-12">
    <table id="executions" class="table table-light table-striped table-borderless table-hover">
      <thead>
        <tr>
          <th scope="col">id</th>
          <th scope="col">job_id</th>
          <th scope="col">status</th>
          <th scope="col">run_time</th>
          <th scope="col">duration</th>
          <th scope="col">finished</th>
          <th scope="col">exception</th>
          <th scope="col">traceback</th>
        </tr>
      </thead>
      <tbody>
        {% for execution in executions %}
        <tr>
          <th scope="row">
            <div class="clickable" data-tableid="results"><span><a
                  href="{% url 'jobs:result' job_execution_id=execution.id %}">{{execution.id}}</a></span>
            </div>
          </th>
          <th scope="row">
            <div class="clickable" data-tableid="results"><span><a
                  href="{% url 'jobs:results_job' job=execution.job_id %}">{{execution.job_id}}</a></span>
            </div>
          </th>
          <th scope="row">{{execution.status}}</th>
          <th scope="row">{{execution.run_time}}</th>
          <th scope="row">{{execution.duration}}</th>
          <th scope="row">{{execution.finished}}</th>
          <th scope="row">{{execution.exception}}</th>
          <th scope="row">{{execution.traceback}}</th>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock content %}

{% block javascript %}
<script src="{% static 'jobs/js/jobs.js' %}"></script>
<script src="{% static 'jobs/js/executions.js' %}"></script>
{% endblock javascript %}

jobs/templates/jobs/index.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'jobs:index' %}">Jobs</a></li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<div class="row">
  <div class="col-lg-12">
    <table id="jobs" class="table table-light table-striped table-borderless table-hover">
      <thead>
        <tr>
          <th scope="col">id</th>
          <th scope="col">next_run_time</th>
          <th scope="col">func</th>
          <th scope="col">args</th>
          <th scope="col">kwargs</th>
          <th scope="col">max_instances</th>
        </tr>
      </thead>
      <tbody>
        {% for job in jobs %}
        <tr>
          <th scope="row">
            <div class="clickable" data-tableid="jobs">
              <span>
                <a href="{% url 'jobs:executions_job' job_id=job.id %}">{{job.id}}</a>
              </span>
            </div>
          </th>
          <th scope="row">{{job.next_run_time}}</th>
          <th scope="row">{{job.func}}</th>
          <th scope="row">{{job.args}}</th>
          <th scope="row">{{job.kwargs}}</th>
          <th scope="row">{{job.max_instances}}</th>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock content %}

{% block javascript %}
<script src="{% static 'jobs/js/jobs.js' %}"></script>
<script>
  connectWebSocket("jobs", uuidv4());
</script>
{% endblock javascript %}

jobs/templates/jobs/results.html
{% extends 'base.html' %}
{% load static %}

{% block sidebar %}
{% endblock sidebar %}

{% block content-title %}
<div class="row">
  <nav title="breadcrumb">
    <ol class="breadcrumb">
      <li class="breadcrumb-item"><a href="{% url 'jobs:index' %}">Jobs</a></li>
      <li class="breadcrumb-item" aria-current="page"><a href="{% url 'jobs:results' %}">Results</a></li>
    </ol>
  </nav>
</div>
{% endblock content-title %}

{% block content %}
<div class="row">
  <div class="col-lg-12">
    <table id="results" class="table table-light table-striped table-borderless table-hover">
      <thead>
        <tr>
          <th scope="col">job_execution_id</th>
          <th scope="col">job_id</th>
          <th scope="col">cmd</th>
          <th scope="col">stdout</th>
        </tr>
      </thead>
      <tbody>
        {% for result in results %}
        <tr>
          <th scope="row">
            <div class="clickable" data-tableid="results">
              <span>
                <a
                  href="{% url 'jobs:result' job_execution_id=result.job_execution_id %}">{{result.job_execution_id}}</a>
              </span>
            </div>
          </th>
          <th scope="row">
            <div class="clickable" data-tableid="results">
              <span>
                <a href="{% url 'jobs:results_job' job=result.job_id %}">{{result.job_id}}</a>
              </span>
            </div>
          </th>
          <th scope="row">{{result.cmd}}</th>
          <th scope="row">{{result.stdout}}</th>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</div>
{% endblock content %}

{% block javascript %}
<script src="{% static 'jobs/js/jobs.js' %}"></script>
<script src="{% static 'jobs/js/results.js' %}"></script>
{% endblock javascript %}